var timeout_id;

window.addEventListener("load", function() {
    var searchbar = document.getElementById("searchbar");
    if(!searchbar || !searchbar.textbox) {
        Components.utils.reportError("searchbar not found");
        return;
    }

    function override(object, methodName, callback) {
        object[methodName] = callback(object[methodName])
    }

    function after(extraBehavior) {
        return function(original) {
            return function() {
                var returnValue = original.apply(this, arguments);
                extraBehavior.apply(this, arguments);
                return returnValue;
            }
        }
    }

    // Monkey patch our auto-clearing behaviour into doSearch,
    // which is the ultimate destination for any search-bar
    // search (click search button, hit enter, or...?).
    //
    // This is compatible with any other addons which patch
    // the same method, as long as they get what they need
    // from this.textbox.value BEFORE calling doSearch.
    override(searchbar, "doSearch", after(function() {
        clearTimeout(timeout_id);
        timeout_id = setTimeout(function () {
            searchbar.textbox.value = "";
        }, 10000);
    }));
}, false);

